
#ifndef DIR_ACCESS_CPP_VER
#define DIR_ACCESS_CPP_VER			0.10.0.0


#define _CRT_RAND_S



BOOL DirIsReadable( LPTSTR DirName )
{
	if ( !DirName )
		return FALSE;


	wchar_t Wildspec[MAX_FILENAME_LEN]		= L"";

	HANDLE FindHandle			= NULL;
	WIN32_FIND_DATA Found;
	BOOL rv						= FALSE;


	wcscpy_s( Wildspec, MAX_FILENAME_LEN, DirName );
	AppendFilename( Wildspec, L"*", MAX_FILENAME_LEN );


	FindHandle = FindFirstFile( Wildspec, &Found );

	if ( FindHandle != INVALID_HANDLE_VALUE ) {
		rv = TRUE;
		FindClose( FindHandle );
	}
	else if ( GetLastError() == ERROR_FILE_NOT_FOUND )
		rv = TRUE;

	return rv;
}



BOOL DirIsWritable( LPTSTR DirName )
{
	if ( !DirName )
		return FALSE;


	wchar_t Filename[MAX_FILENAME_LEN]		= L"";
	wchar_t TempName[SHORT_BUF_LEN]			= L"";

	unsigned int Random				= 0;
	HANDLE FileHandle				= NULL;
	BOOL rv							= FALSE;
	BOOL Done						= FALSE;
	int k							= 0;


	do {
		rand_s( &Random );
		wsprintf( TempName, L"Test-%04X-%08X.$$$", GetCurrentProcessId(), Random );
		wcscpy_s( Filename, MAX_FILENAME_LEN, DirName );
		AppendFilename( Filename, TempName, MAX_FILENAME_LEN );

		//	wprintf( L"   *  Filename = %s\n", Filename );

		FileHandle = CreateFile( Filename, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_FLAG_DELETE_ON_CLOSE, NULL );

		if ( FileHandle != INVALID_HANDLE_VALUE ) {
			CloseHandle( FileHandle );
			Done = TRUE;
			rv = TRUE;
		}
		else {
			k++;
			if ( k > 20 )
				Done = TRUE;
		}
	}
	while ( !Done );

	return rv;
}



DLLExports int WINAPI f_dirreadable( LPTSTR String )
{
	if ( !String )
		return 1;


	wchar_t Filename[MAX_FILENAME_LEN]		= L"";

	unsigned int rv			= 0;


	TrimLine( String );
	StripQuotes( String );


	if ( String[0] == '\0' ) {
		DisplayErrorHeader();
		Qprintf( ERRHANDLE, L"Missing filename\r\n" );
		return -1;
	}

	FH_Truename( String, Filename );
	if ( Filename[0] == '\0' ) {
		DisplayErrorHeader();
		Qprintf( ERRHANDLE, L"Bad filename: \"%s\"\r\n", String );
		return -1;
	}

	if ( DirIsReadable( Filename ) )
		rv = 1;

	_ultow_s( rv, String, MAX_ARG_LEN, 10 );
	return 0;
}



DLLExports int WINAPI f_dirwritable( LPTSTR String )
{
	if ( !String )
		return 1;


	wchar_t Filename[MAX_FILENAME_LEN]		= L"";

	unsigned int rv			= 0;


	TrimLine( String );
	StripQuotes( String );


	if ( String[0] == '\0' ) {
		DisplayErrorHeader();
		Qprintf( ERRHANDLE, L"Missing filename\r\n" );
		return -1;
	}

	FH_Truename( String, Filename );
	if ( Filename[0] == '\0' ) {
		DisplayErrorHeader();
		Qprintf( ERRHANDLE, L"Bad filename: \"%s\"\r\n", String );
		return -1;
	}

	if ( DirIsWritable( Filename ) )
		rv = 1;

	_ultow_s( rv, String, MAX_ARG_LEN, 10 );
	return 0;
}



#endif	//	DIR_ACCESS_CPP_VER
